From efe27e0775367e57921f7946b51bc9a7bd486bf8 Mon Sep 17 00:00:00 2001
From: Mat Booth <mat.booth@redhat.com>
Date: Mon, 7 Sep 2020 13:41:44 +0100
Subject: [PATCH 4/7] Remove optional dep tcnative

---
 handler/pom.xml                               |   11 -
 .../handler/ssl/CipherSuiteConverter.java     |  496 ----
 .../ssl/DefaultOpenSslKeyMaterial.java        |  126 -
 .../java/io/netty/handler/ssl/OpenSsl.java    |  726 -----
 .../ssl/OpenSslAsyncPrivateKeyMethod.java     |   58 -
 .../OpenSslCachingKeyMaterialProvider.java    |   79 -
 .../OpenSslCachingX509KeyManagerFactory.java  |   80 -
 .../ssl/OpenSslCertificateException.java      |   81 -
 .../handler/ssl/OpenSslClientContext.java     |  211 --
 .../io/netty/handler/ssl/OpenSslContext.java  |   60 -
 .../handler/ssl/OpenSslContextOption.java     |   71 -
 .../io/netty/handler/ssl/OpenSslEngine.java   |   41 -
 .../netty/handler/ssl/OpenSslEngineMap.java   |   35 -
 .../ssl/OpenSslKeyMaterialManager.java        |  138 -
 .../ssl/OpenSslKeyMaterialProvider.java       |  154 -
 .../netty/handler/ssl/OpenSslPrivateKey.java  |  191 --
 .../handler/ssl/OpenSslPrivateKeyMethod.java  |   62 -
 .../handler/ssl/OpenSslServerContext.java     |  371 ---
 .../ssl/OpenSslServerSessionContext.java      |   50 -
 .../handler/ssl/OpenSslSessionContext.java    |  229 --
 .../handler/ssl/OpenSslSessionStats.java      |  253 --
 .../handler/ssl/OpenSslSessionTicketKey.java  |   78 -
 .../ssl/OpenSslX509KeyManagerFactory.java     |  416 ---
 .../ReferenceCountedOpenSslClientContext.java |  319 --
 .../ssl/ReferenceCountedOpenSslContext.java   | 1129 -------
 .../ssl/ReferenceCountedOpenSslEngine.java    | 2641 -----------------
 .../ReferenceCountedOpenSslServerContext.java |  298 --
 .../java/io/netty/handler/ssl/SslContext.java |   32 +-
 .../java/io/netty/handler/ssl/SslHandler.java |   47 +-
 .../handler/ssl/SslMasterKeyHandler.java      |    3 -
 .../io/netty/handler/ssl/SslProvider.java     |   20 +-
 .../handler/ssl/ocsp/OcspClientHandler.java   |   61 -
 .../netty/handler/ssl/ocsp/package-info.java  |   23 -
 pom.xml                                       |   17 -
 34 files changed, 3 insertions(+), 8604 deletions(-)
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/CipherSuiteConverter.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/DefaultOpenSslKeyMaterial.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSsl.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslAsyncPrivateKeyMethod.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslCachingKeyMaterialProvider.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslCachingX509KeyManagerFactory.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslCertificateException.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslClientContext.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslContext.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslContextOption.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslEngine.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslEngineMap.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslKeyMaterialManager.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslKeyMaterialProvider.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslPrivateKey.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslPrivateKeyMethod.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslServerContext.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslServerSessionContext.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslSessionContext.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslSessionStats.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslSessionTicketKey.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/OpenSslX509KeyManagerFactory.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/ReferenceCountedOpenSslClientContext.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/ReferenceCountedOpenSslContext.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/ReferenceCountedOpenSslEngine.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/ReferenceCountedOpenSslServerContext.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/ocsp/OcspClientHandler.java
 delete mode 100644 handler/src/main/java/io/netty/handler/ssl/ocsp/package-info.java

diff --git a/handler/src/main/java/io/netty/handler/ssl/SslContext.java b/handler/src/main/java/io/netty/handler/ssl/SslContext.java
index ff93d4011c..1c8efb7151 100644
--- a/handler/src/main/java/io/netty/handler/ssl/SslContext.java
+++ b/handler/src/main/java/io/netty/handler/ssl/SslContext.java
@@ -121,11 +121,7 @@ public abstract class SslContext {
     }
 
     private static SslProvider defaultProvider() {
-        if (OpenSsl.isAvailable()) {
-            return SslProvider.OPENSSL;
-        } else {
-            return SslProvider.JDK;
-        }
+        return SslProvider.JDK;
     }
 
     /**
@@ -468,18 +464,6 @@ public abstract class SslContext {
                     trustCertCollection, trustManagerFactory, keyCertChain, key, keyPassword,
                     keyManagerFactory, ciphers, cipherFilter, apn, sessionCacheSize, sessionTimeout,
                     clientAuth, protocols, startTls, keyStoreType);
-        case OPENSSL:
-            verifyNullSslContextProvider(provider, sslContextProvider);
-            return new OpenSslServerContext(
-                    trustCertCollection, trustManagerFactory, keyCertChain, key, keyPassword,
-                    keyManagerFactory, ciphers, cipherFilter, apn, sessionCacheSize, sessionTimeout,
-                    clientAuth, protocols, startTls, enableOcsp, keyStoreType, ctxOptions);
-        case OPENSSL_REFCNT:
-            verifyNullSslContextProvider(provider, sslContextProvider);
-            return new ReferenceCountedOpenSslServerContext(
-                    trustCertCollection, trustManagerFactory, keyCertChain, key, keyPassword,
-                    keyManagerFactory, ciphers, cipherFilter, apn, sessionCacheSize, sessionTimeout,
-                    clientAuth, protocols, startTls, enableOcsp, keyStoreType, ctxOptions);
         default:
             throw new Error(provider.toString());
         }
@@ -825,20 +809,6 @@ public abstract class SslContext {
                         trustCert, trustManagerFactory, keyCertChain, key, keyPassword,
                         keyManagerFactory, ciphers, cipherFilter, apn, protocols, sessionCacheSize,
                         sessionTimeout, keyStoreType);
-            case OPENSSL:
-                verifyNullSslContextProvider(provider, sslContextProvider);
-                OpenSsl.ensureAvailability();
-                return new OpenSslClientContext(
-                        trustCert, trustManagerFactory, keyCertChain, key, keyPassword,
-                        keyManagerFactory, ciphers, cipherFilter, apn, protocols, sessionCacheSize, sessionTimeout,
-                        enableOcsp, keyStoreType, options);
-            case OPENSSL_REFCNT:
-                verifyNullSslContextProvider(provider, sslContextProvider);
-                OpenSsl.ensureAvailability();
-                return new ReferenceCountedOpenSslClientContext(
-                        trustCert, trustManagerFactory, keyCertChain, key, keyPassword,
-                        keyManagerFactory, ciphers, cipherFilter, apn, protocols, sessionCacheSize, sessionTimeout,
-                        enableOcsp, keyStoreType, options);
             default:
                 throw new Error(provider.toString());
         }
diff --git a/handler/src/main/java/io/netty/handler/ssl/SslHandler.java b/handler/src/main/java/io/netty/handler/ssl/SslHandler.java
index 73f1bdad3c..ac9f2ed35c 100644
--- a/handler/src/main/java/io/netty/handler/ssl/SslHandler.java
+++ b/handler/src/main/java/io/netty/handler/ssl/SslHandler.java
@@ -198,51 +198,6 @@ public class SslHandler extends ByteToMessageDecoder implements ChannelOutboundH
     private static final int MAX_PLAINTEXT_LENGTH = 16 * 1024;
 
     private enum SslEngineType {
-        TCNATIVE(true, COMPOSITE_CUMULATOR) {
-            @Override
-            SSLEngineResult unwrap(SslHandler handler, ByteBuf in, int len, ByteBuf out) throws SSLException {
-                int nioBufferCount = in.nioBufferCount();
-                int writerIndex = out.writerIndex();
-                final SSLEngineResult result;
-                if (nioBufferCount > 1) {
-                    /*
-                     * If {@link OpenSslEngine} is in use,
-                     * we can use a special {@link OpenSslEngine#unwrap(ByteBuffer[], ByteBuffer[])} method
-                     * that accepts multiple {@link ByteBuffer}s without additional memory copies.
-                     */
-                    ReferenceCountedOpenSslEngine opensslEngine = (ReferenceCountedOpenSslEngine) handler.engine;
-                    try {
-                        handler.singleBuffer[0] = toByteBuffer(out, writerIndex, out.writableBytes());
-                        result = opensslEngine.unwrap(in.nioBuffers(in.readerIndex(), len), handler.singleBuffer);
-                    } finally {
-                        handler.singleBuffer[0] = null;
-                    }
-                } else {
-                    result = handler.engine.unwrap(toByteBuffer(in, in.readerIndex(), len),
-                        toByteBuffer(out, writerIndex, out.writableBytes()));
-                }
-                out.writerIndex(writerIndex + result.bytesProduced());
-                return result;
-            }
-
-            @Override
-            ByteBuf allocateWrapBuffer(SslHandler handler, ByteBufAllocator allocator,
-                                       int pendingBytes, int numComponents) {
-                return allocator.directBuffer(((ReferenceCountedOpenSslEngine) handler.engine)
-                        .calculateMaxLengthForWrap(pendingBytes, numComponents));
-            }
-
-            @Override
-            int calculatePendingData(SslHandler handler, int guess) {
-                int sslPending = ((ReferenceCountedOpenSslEngine) handler.engine).sslPending();
-                return sslPending > 0 ? sslPending : guess;
-            }
-
-            @Override
-            boolean jdkCompatibilityMode(SSLEngine engine) {
-                return ((ReferenceCountedOpenSslEngine) engine).jdkCompatibilityMode;
-            }
-        },
         JDK(false, MERGE_CUMULATOR) {
             @Override
             SSLEngineResult unwrap(SslHandler handler, ByteBuf in, int len, ByteBuf out) throws SSLException {
@@ -294,7 +249,7 @@ public class SslHandler extends ByteToMessageDecoder implements ChannelOutboundH
         };
 
         static SslEngineType forEngine(SSLEngine engine) {
-            return engine instanceof ReferenceCountedOpenSslEngine ? TCNATIVE : JDK;
+            return JDK;
         }
 
         SslEngineType(boolean wantsDirectBuffer, Cumulator cumulator) {
diff --git a/handler/src/main/java/io/netty/handler/ssl/SslMasterKeyHandler.java b/handler/src/main/java/io/netty/handler/ssl/SslMasterKeyHandler.java
index 231bd7985e..38bd913993 100644
--- a/handler/src/main/java/io/netty/handler/ssl/SslMasterKeyHandler.java
+++ b/handler/src/main/java/io/netty/handler/ssl/SslMasterKeyHandler.java
@@ -139,9 +139,6 @@ public abstract class SslMasterKeyHandler extends ChannelInboundHandlerAdapter {
                             "via reflection.", e);
                 }
                 accept(secretKey, sslSession);
-            } else if (OpenSsl.isAvailable() && engine instanceof ReferenceCountedOpenSslEngine) {
-                SecretKeySpec secretKey = ((ReferenceCountedOpenSslEngine) engine).masterKey();
-                accept(secretKey, sslSession);
             }
         }
 
diff --git a/handler/src/main/java/io/netty/handler/ssl/SslProvider.java b/handler/src/main/java/io/netty/handler/ssl/SslProvider.java
index 9f890e2e79..0bc7c5b156 100644
--- a/handler/src/main/java/io/netty/handler/ssl/SslProvider.java
+++ b/handler/src/main/java/io/netty/handler/ssl/SslProvider.java
@@ -28,16 +28,7 @@ public enum SslProvider {
     /**
      * JDK's default implementation.
      */
-    JDK,
-    /**
-     * OpenSSL-based implementation.
-     */
-    OPENSSL,
-    /**
-     * OpenSSL-based implementation which does not have finalizers and instead implements {@link ReferenceCounted}.
-     */
-    @UnstableApi
-    OPENSSL_REFCNT;
+    JDK;
 
     /**
      * Returns {@code true} if the specified {@link SslProvider} supports
@@ -48,9 +39,6 @@ public enum SslProvider {
         switch (provider) {
             case JDK:
                 return JdkAlpnApplicationProtocolNegotiator.isAlpnSupported();
-            case OPENSSL:
-            case OPENSSL_REFCNT:
-                return OpenSsl.isAlpnSupported();
             default:
                 throw new Error("Unknown SslProvider: " + provider);
         }
@@ -72,9 +60,6 @@ public enum SslProvider {
         switch (sslProvider) {
             case JDK:
                 return SslUtils.isTLSv13SupportedByJDK(provider);
-            case OPENSSL:
-            case OPENSSL_REFCNT:
-                return OpenSsl.isTlsv13Supported();
             default:
                 throw new Error("Unknown SslProvider: " + sslProvider);
         }
@@ -88,9 +73,6 @@ public enum SslProvider {
         switch (sslProvider) {
             case JDK:
                 return SslUtils.isTLSv13EnabledByJDK(provider);
-            case OPENSSL:
-            case OPENSSL_REFCNT:
-                return OpenSsl.isTlsv13Supported();
             default:
                 throw new Error("Unknown SslProvider: " + sslProvider);
         }
